class String
  def constantize(base = Object)
    split("::").inject(base) do |mod, name|
      mod.const_get(name)
    end
  end unless defined?(constantize)
  
  def camelize
    capitalize.gsub(/_(.)/) do
      $1.upcase
    end
  end unless defined?(camelize)
end

class Module
  def namespace
    parts = name.split("::")
    if parts.length == 1
      Object
    else
      parts[0..-2].join("::").constantize
    end
  end
end

