module IRC
  module Handlers
    class IdentityHandler < Event::Handler
      attr_reader :nickname, :username, :realname

      def on_connection_established
        @nickname = options[:nickname] || "ruby-irc"
        @username = options[:username] || "ruby-irc"
        @realname = options[:realname] || "Ruby IRC"

        request(:user, username, 0, 0, :text => realname)
        change_nickname_to(nickname)
      end
      
      def on_001
        @nickname = response.args.first
      end
      
      def on_432 # ERR_ERRONEUSNICKNAME
        change_nickname_to("ruby-irc")
      end
      
      def on_433 # ERR_NICKNAMEINUSE
        change_nickname_to(nickname + "_")
      end
      
      def on_nick
        if normalize(response.from.nickname) == normalize(nickname)
          @nickname = response.text
        end
      end
      
      protected
        def change_nickname_to(nickname)
          request(:nick, nickname)
        end
    end
  end
end
